// Main program and "Tracker_Definitions.h" modified by DJ7OO 
// unused #defines blocked
// port for PLED1 changed to = #8
// Baudrate changed to 125[KHz]
// Bulletin sending removed

#define programname "LoRaTracker_Relay"
#define programversion "V1.1"
#define dateproduced "130816"
#define aurthorname "Stuart Robinson"

/***************************************************************************************************
Easy Build LoRaTracker Programs for Arduino ATMEGA328
Copyright of the author Stuart Robinson - 13/08/2016
HTTP://WWW.LORATRACKER.UK
These programs may be used free of charge for personal, recreational and educational purposes only.
This program, or parts of it, may not be used for or in connection with any commercial purpose without
the explicit permission of the author Stuart Robinson.
The programs are supplied as is, it is up to individual to decide if the programs are suitable for the
intended purpose and free from errors.
To Do:
***************************************************************************************************/
                         
#define Relay                         // specify PCB type 

#include <Arduino.h>
#include "Tracker_Definitions.h"
#include <SPI.h>
#include "LoRa.h"

const float Frequency1 = 434.400;
const float FreqOffset = 0.0;

// const byte relay_Bandwidth = lora_BW41_7;
// const byte relay_Bandwidth = lora_BW62_5;
 const byte relay_Bandwidth = lora_BW125;

const byte relay_SpreadFactor = lora_SF12;
const byte relay_CodeRate = lora_CR4_5;
const byte relay_RateOptimisation = lora_LowDoptON;
const byte relay_Power = 10;
const char ThisNode = 'R';
const unsigned int Inter_Packet_Delay = 2000;  //delay from reception of packet to re-transmit

//////////////////////////////////////////////////////////
void loop()
{
  init_LoRa();
  lora_RXONLoRa();
  while (!lora_Read(lora_RegIrqFlags));
  checkforpacket();
}

//////////////////////////////////////////////////////////
void checkforpacket()
{
// check if a packet has been received
  byte lora_Ltemp;
  lora_Ltemp = lora_Read(lora_RegIrqFlags);
  if (lora_Ltemp == 64)
  {
    lora_RXOFF();                                       //stop more packets coming in
    digitalWrite(PLED1, HIGH);
    Serial.print("Recieved Packet ");
    lora_PrintPacketInfo();                             //print the info on received packet
    Serial.println();
    delay(Inter_Packet_Delay);
    Serial.print("Re-Transmitting");
    lora_SendFIFO(lora_PacketL, 10, relay_Power);
    Serial.println(" - Done");
    digitalWrite(PLED1, LOW); 
    delay(Inter_Packet_Delay);

/////////////////////////////////////////////////////////////
  Serial.println();
  }
  if (lora_Ltemp == 96)
  {
    Serial.println();
    Serial.println(F("CRC Error"));
  }
}

//////////////////////////////////////////////////////////////////
void led_Flash(unsigned int flashdelay, unsigned int flashes)
{
// flash LED right at start so we can tell board is alive
  unsigned int i;
  for (i = 1; i <= flashes; i++)
  {
    delay(flashdelay);
    digitalWrite(PLED1, HIGH);
    delay(flashdelay);
    digitalWrite(PLED1, LOW);
  }
}

/////////////////////////////////////////////////////////////////
void init_LoRa()
{
  lora_Setup();                               // reset and initialise LoRa device
  lora_SetFreq(Frequency1, FreqOffset);       // set the operating frequency
  lora_SetModem(relay_Bandwidth, relay_SpreadFactor, relay_CodeRate, lora_Explicit, relay_RateOptimisation);	// setup the LoRa modem parameters
}

///////////////////////////////////////////////////////////////////
void setup()
{  
  pinMode(PLED1, OUTPUT);                      // setup pin for PCB LED
  led_Flash(100, 5);
//  Serial.begin(38400);                         // serial console ouput baud rate
  Serial.begin(19200);                         // serial console ouput baud rate
  Serial.println(F(programname));
  Serial.println(F(programversion));
  Serial.println(F(dateproduced));
  Serial.println(F(aurthorname));
  pinMode(lora_PReset, OUTPUT);                // LoRa device reset line
  pinMode (lora_PNSS, OUTPUT);        // set the slave select pin as an output
  digitalWrite(lora_PNSS, HIGH);               // enable
  SPI.begin();                                 // initialize SPI
  SPI.setClockDivider(SPI_CLOCK_DIV2);
  SPI.setDataMode(SPI_MODE0);
  SPI.setBitOrder(MSBFIRST);
  if (lora_CheckDevice() == 1)
  {
  Serial.println(F("Device Error"));
  while (1)
    {
      led_Flash(25, 10);
    }
  }
  Serial.println("Ready");
}


